import java.awt.*;
import java.awt.image.*;
import javax.media.opengl.*;
import com.sun.opengl.util.*;
import com.sun.opengl.util.texture.*;
import javax.media.opengl.glu.*;
import java.nio.*;
import com.cycling74.max.*;

public class DIPSScreenCapture extends MaxObject {
	GLContext glContext;
	GL gl;
	boolean initialized = false;
	DIPSRobot robot;
	int x, y, width, height;
	ByteBuffer dest;
	boolean aborted = false;
	int c = 0;
				
	public DIPSScreenCapture() {
		dest = null;
		try { robot = new DIPSRobot(); }
		catch ( Exception e ) {}
		setRegion( 100, 100, 512, 512 );
		new Thread() {
			public void run() {
				while( true ) {
					//data = ((DataBufferInt) robot.createScreenCapture( new Rectangle( x, y, width, height ) ).getRaster().getDataBuffer()).getData();
					c++;
					if ( c >= 64 ) c = 0;
					data =  robot.doScreenCapture( new Rectangle( x+64*(c/8), y+64*(c%8), 64, 64 ) );
					//post( data.length+"" );
					
					
					
					for ( int i = 0; i < 64*64; i++ ) {
						for ( int p = 0; p < 3; p++ ) {
							buf[ i * 3 + p ] = new Integer( data[ i ] ).byteValue();
							data[ i ] = data [ i ] >> 8;
						}
					}
					
					//dest.asIntBuffer().put(buf, 0, data.length);
					dest.position( 0 );
					dest.put( buf, 0, buf.length );
					if ( aborted ) return;
				}
			}
		}.start();
		
	}
	public void notifyDeleted() {
    	System.gc();
		aborted = true;
    }
	byte[] buf;
	public void setRegion( int x, int y, int width, int height ) {
		this.x = x;
		this.y = y;
		this.width = width;
		this.height = height;
		initialized = false;
		buf = new byte[ 64*64* 3 ];
		dest = ByteBuffer.allocateDirect(64*64*3);
		dest.order(ByteOrder.nativeOrder());
		
	}
	int[] data;
	public void bang() {
		if ( !initialized ) {
			glContext = GLDrawableFactory.getFactory().createExternalGLContext();
			gl = glContext.getGL();
			gl.glTexParameteri( GL.GL_TEXTURE_RECTANGLE_EXT, GL.GL_TEXTURE_MIN_FILTER, GL.GL_LINEAR );
			gl.glTexParameteri( GL.GL_TEXTURE_RECTANGLE_EXT, GL.GL_TEXTURE_MAG_FILTER, GL.GL_LINEAR );
			gl.glTexImage2D( GL.GL_TEXTURE_RECTANGLE_EXT, 0, GL.GL_RGBA, 512, 512, 0, GL.GL_BGR, GL.GL_UNSIGNED_BYTE, ByteBuffer.allocateDirect(512*512*3) );
		
			initialized = true;
		}
		if ( gl != null ) {
			glContext.makeCurrent();
			//gl.glTexSubImage2D( GL.GL_TEXTURE_RECTANGLE_EXT, 0, 0, 0, width, height, GL.GL_COLOR_INDEX, GL.GL_UNSIGNED_INT_8_8_8_8_REV, dest );
			dest.position( 0 );
			gl.glTexSubImage2D( GL.GL_TEXTURE_RECTANGLE_EXT, 0, 64*(c/8), 64*(c%8), 64, 64, GL.GL_BGR, GL.GL_UNSIGNED_BYTE, dest );
			glContext.release();
		}
		outletBang( 0 );
	
	}
	
}
