import com.cycling74.max.*;
import com.cycling74.net.UdpReceiver;

public class receiver extends MaxObject {
    UdpReceiver receiver;
    public receiver( Atom aatom[] ) {
        declareOutlets( new int[] { 15, 15 } );
        receiver = new UdpReceiver();
        receiver.setCallback( this, "received" );
        receiver.setActive( true );
    }
	public void setPort( int port ) {
		receiver.setPort( port );
	}
    public void received( Atom aatom[] ) {
		if ( aatom.length == 1 ) {
			if ( aatom[ 0 ].isInt() ) {
				outlet( 0, aatom[ 0 ].getInt() );
			} else if ( aatom[ 0 ].isFloat() ) {
				outlet( 0, aatom[ 0 ].getFloat() );
			} else {
				outlet( 1, aatom[ 0 ] );
				outletBang( 0 );
			}
		} else {
			if ( aatom[ 0 ].getString().equals( "bang" ) ) {
				outlet( 0, Atom.removeFirst( aatom ) );
			} else {
				outlet( 1, aatom[ 0 ] );
				outlet( 0, Atom.removeFirst( aatom ) );
			}
		}
    }
    public void notifyDeleted() {
        receiver.close();
    }
}
