import java.awt.*;
import java.awt.image.*;
import javax.media.opengl.*;
import com.sun.opengl.util.*;
import com.sun.opengl.util.texture.*;
import javax.media.opengl.glu.*;
import java.nio.*;
import com.cycling74.max.*;

public class DIPSMotionDetect extends MaxObject {
	GLContext glContext;
	GL gl;
	
	public DIPSMotionDetect() {
	}
	public void notifyDeleted() {
    	System.gc();
    }
	
	boolean initialized = false;
	int[] tmp;
	boolean texNum = false;
	public void bang() {
		if ( !initialized ) {
			glContext = GLDrawableFactory.getFactory().createExternalGLContext();
			gl = glContext.getGL();
			tmp = new int[ 2 ];
			gl.glGenTextures( 2, tmp, 0 );
			for ( int i = 0; i < tmp.length; i++ ) {
				gl.glBindTexture( GL.GL_TEXTURE_RECTANGLE_EXT, tmp[ i ] );
				gl.glTexParameteri( GL.GL_TEXTURE_RECTANGLE_EXT, GL.GL_TEXTURE_MIN_FILTER, GL.GL_LINEAR );
				gl.glTexParameteri( GL.GL_TEXTURE_RECTANGLE_EXT, GL.GL_TEXTURE_MAG_FILTER, GL.GL_LINEAR );
				gl.glTexGeni( GL.GL_S, GL.GL_TEXTURE_GEN_MODE, GL.GL_OBJECT_LINEAR );
				gl.glTexGeni( GL.GL_T, GL.GL_TEXTURE_GEN_MODE, GL.GL_OBJECT_LINEAR );
				float width = 640f, height = 480f;
				gl.glCopyTexImage2D( GL.GL_TEXTURE_RECTANGLE_EXT, 0, GL.GL_RGB, 0, 0, (int)width, (int)height, 0 );
				
			}
			initialized = true;
		}
		if ( gl != null ) {
			int[] bounds = new int[ 4 ];
			gl.glGetIntegerv( GL.GL_VIEWPORT, bounds, 0 );
			float width = bounds[2], height = bounds[3];
			glContext.makeCurrent();
			gl.glPushAttrib( GL.GL_ALL_ATTRIB_BITS );
			gl.glBindTexture( GL.GL_TEXTURE_RECTANGLE_EXT, tmp[ texNum ? 0 : 1  ] );
				
			gl.glCopyTexImage2D( GL.GL_TEXTURE_RECTANGLE_EXT, 0, GL.GL_RGB, 0, 0, (int)width, (int)height, 0 );
			
			gl.glBindTexture( GL.GL_TEXTURE_RECTANGLE_EXT, tmp[ !texNum ? 0 : 1  ] );
			gl.glTexGeni( GL.GL_S, GL.GL_TEXTURE_GEN_MODE, GL.GL_OBJECT_LINEAR );
			gl.glTexGeni( GL.GL_T, GL.GL_TEXTURE_GEN_MODE, GL.GL_OBJECT_LINEAR );
			gl.glEnable( GL.GL_TEXTURE_GEN_S );
			gl.glEnable( GL.GL_TEXTURE_GEN_T );
			gl.glDisable( GL.GL_DEPTH_TEST );	
			gl.glMatrixMode( GL.GL_TEXTURE );
			gl.glPushMatrix();
			gl.glLoadIdentity();
			gl.glMatrixMode( GL.GL_PROJECTION );
			gl.glPushMatrix();
			gl.glLoadIdentity();
			gl.glOrtho( 0, width, 0, height, -1, 1 );
			gl.glMatrixMode( GL.GL_MODELVIEW );
			gl.glPushMatrix();
			gl.glLoadIdentity();
			gl.glEnable( GL.GL_TEXTURE_RECTANGLE_EXT );
			gl.glEnable( GL.GL_BLEND );
			gl.glBlendFunc( GL.GL_ONE, GL.GL_ONE );
			
			//gl.glBlendEquation( GL.GL_FUNC_SUBTRACT );
			gl.glBlendEquation( GL.GL_FUNC_SUBTRACT );
			
			gl.glColor4f( 1f, 1f, 1f, 1f );
			gl.glBegin( GL.GL_QUADS );
			gl.glVertex3f( width, height, 0 );
			gl.glVertex3f( width, 0, 0 );
			gl.glVertex3f( 0, 0, 0 );
			gl.glVertex3f( 0, height, 0 );
			gl.glEnd();
			texNum = !texNum;
			
			gl.glDisable( GL.GL_TEXTURE_RECTANGLE_EXT );
			gl.glDisable( GL.GL_BLEND );
			
			gl.glMatrixMode( GL.GL_TEXTURE );
			gl.glPopMatrix();
			gl.glMatrixMode( GL.GL_PROJECTION );
			gl.glPopMatrix();
			gl.glMatrixMode( GL.GL_MODELVIEW );
			gl.glPopMatrix();
			
			gl.glBlendEquation( GL.GL_FUNC_ADD );
			
			gl.glPopAttrib();
			glContext.release();
			
		}
		outletBang( 0 );
	}

}
