import java.awt.*;
import java.awt.peer.RobotPeer;
import java.awt.image.*;
import sun.awt.ComponentFactory;

public class DIPSRobot extends Robot {
	private RobotPeer peer;
    private Point gdLoc;
	
	public DIPSRobot() throws AWTException {
		Toolkit toolkit = Toolkit.getDefaultToolkit();
		GraphicsDevice graphicsdevice = GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice();
        if(toolkit instanceof ComponentFactory)
            peer = ((ComponentFactory)toolkit).createRobot(this, graphicsdevice);
		gdLoc = graphicsdevice.getDefaultConfiguration().getBounds().getLocation();
        
	}
	public int[] doScreenCapture( Rectangle rect ) {
		rect.translate(gdLoc.x, gdLoc.y);
		if(rect.width <= 0 || rect.height <= 0) {
			throw new IllegalArgumentException("Rectangle width and height must be > 0");
		}
		//screenCapCM = new DirectColorModel(24, 0xff0000, 65280, 255);
		//int ai1[] = new int[3];
		return peer.getRGBPixels(rect);
		
		/*
		DataBufferInt databufferint = new DataBufferInt(ai, ai.length);
		int[] buf = databufferint.getData();
		System.out.println( buf.length );
		try {
			java.io.FileWriter writer = new java.io.FileWriter( new java.io.File( "a.txt" ) );
			for ( int i = 0; i < buf.length; i++ ) {
				System.out.print( buf[ i ] + "\t" );
				writer.write( "" + buf[ i ] );
			}
			writer.close();
		} catch ( Exception e ) {}
		*/
		
		/*
		byte[] buf = new byte[ ai.length * 4 ];
		System.out.println( ai.length );
		
		for ( int i = 0; i < ai.length; i++ ) {
			//System.out.print( ai[ i ] + "\t" );
			for ( int p = 0; p < 4; p++ ) {
				buf[ i * 4 + p ] = new Integer( ai[ i ] ).byteValue();
				ai[ i ] = ai [ i ] >> 8;
				System.out.print( buf[ i * 4 + p ] + "\t" );
			}
			System.out.println();
		}
		*/
		/*
		ai1[0] = screenCapCM.getRedMask();
		ai1[1] = screenCapCM.getGreenMask();
		ai1[2] = screenCapCM.getBlueMask();
		java.awt.image.WritableRaster writableraster = Raster.createPackedRaster(databufferint, rectangle1.width, rectangle1.height, rectangle1.width, ai1, null);
		BufferedImage bufferedimage = new BufferedImage(screenCapCM, writableraster, false, null);
		*/
		//return;
    }

}